"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var HttpTracingModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpTracingModule = void 0;
const axios_1 = require("axios");
const common_1 = require("@nestjs/common");
const random_string_generator_util_1 = require("@nestjs/common/utils/random-string-generator.util");
const nest_stack_tracing_1 = require("@zcong/nest-stack-tracing");
const http_constants_1 = require("./http.constants");
const http_service_1 = require("./http.service");
let HttpTracingModule = HttpTracingModule_1 = class HttpTracingModule {
    static register(config, global = false) {
        const imports = [];
        if (config.withTracing) {
            imports.push(nest_stack_tracing_1.TracerModule);
        }
        return {
            global,
            module: HttpTracingModule_1,
            providers: [
                {
                    provide: http_constants_1.NEST_STACK_HTTP_MODULE_ID,
                    useValue: random_string_generator_util_1.randomStringGenerator(),
                },
                {
                    provide: http_constants_1.NEST_STACK_HTTP_MODULE_OPTIONS,
                    useValue: config,
                },
            ],
            imports,
        };
    }
    static registerAsync(options, global = false) {
        return {
            global,
            module: HttpTracingModule_1,
            imports: options.imports,
            providers: [
                ...this.createAsyncProviders(options),
                {
                    provide: http_constants_1.NEST_STACK_AXIOS_INSTANCE_TOKEN,
                    useFactory: (config) => axios_1.default.create(config),
                    inject: [http_constants_1.NEST_STACK_HTTP_MODULE_OPTIONS],
                },
                {
                    provide: http_constants_1.NEST_STACK_HTTP_MODULE_ID,
                    useValue: random_string_generator_util_1.randomStringGenerator(),
                },
                ...(options.extraProviders || []),
            ],
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: options.useClass,
                useClass: options.useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: http_constants_1.NEST_STACK_HTTP_MODULE_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: http_constants_1.NEST_STACK_HTTP_MODULE_OPTIONS,
            useFactory: async (optionsFactory) => optionsFactory.createHttpOptions(),
            inject: [options.useExisting || options.useClass],
        };
    }
};
HttpTracingModule = HttpTracingModule_1 = __decorate([
    common_1.Module({
        providers: [
            http_service_1.HttpTracingService,
            {
                provide: http_constants_1.NEST_STACK_AXIOS_INSTANCE_TOKEN,
                useValue: axios_1.default,
            },
        ],
        exports: [http_service_1.HttpTracingService],
    })
], HttpTracingModule);
exports.HttpTracingModule = HttpTracingModule;
//# sourceMappingURL=http.module.js.map