import { AxiosInstance, AxiosRequestConfig, AxiosResponse } from 'axios';
import { Observable } from 'rxjs';
import { HttpService as BaseHttpService } from '@nestjs/common';
import { Tracer } from 'opentracing';
import { HttpModuleOptions } from './http.interfaces';
export declare class HttpTracingService extends BaseHttpService {
    private redirectHeaderKeys;
    private readonly tracer;
    private readonly config?;
    constructor(config?: HttpModuleOptions, instance?: AxiosInstance, tracer?: Tracer);
    request<T = any>(config: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    get<T = any>(url: string, config?: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    delete<T = any>(url: string, config?: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    head<T = any>(url: string, config?: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    post<T = any>(url: string, data?: any, config?: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    put<T = any>(url: string, data?: any, config?: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    patch<T = any>(url: string, data?: any, config?: AxiosRequestConfig): Observable<AxiosResponse<T>>;
    private traceWrapper;
    private injectRedirectHeadersToConfig;
    private getRequestContextHeaders;
    private getRequestId;
}
